/**
 * An implementation of Set backed by Dict
 * Values can be anything, with deep-equality comparison
 * API compatible with native Set
 */
export declare class DSet<V> implements Iterable<V> {
    static from<V>(): DSet<V>;
    static from<V>(array: readonly V[]): DSet<V>;
    static from<V>(set: Set<V>): DSet<V>;
    private dict;
    constructor();
    constructor(values: readonly V[] | null);
    constructor(iterable: Iterable<V> | null);
    add(val: V): DSet<V>;
    clear(): void;
    delete(val: V): DSet<V>;
    difference(other: DSet<V>): DSet<V>;
    entries(): IteratorObject<V[], undefined, unknown>;
    forEach(fn: (val: V) => void): void;
    has(val: V): boolean;
    intersection(other: DSet<V>): DSet<V>;
    isDisjointFrom(other: DSet<V>): boolean;
    isSubsetOf(other: DSet<V>): boolean;
    isSupersetOf(other: DSet<V>): boolean;
    keys(): IteratorObject<V, undefined, unknown>;
    symmetricDifference(other: DSet<V>): DSet<V>;
    union(other: DSet<V>): DSet<V>;
    values(): IteratorObject<V, undefined, unknown>;
    [Symbol.iterator](): IteratorObject<V, undefined, unknown>;
    get size(): number;
    hashCode(): number;
    equals(o: DSet<V>): boolean;
}
